// Code generated by "enumer -type=FileSystemAction -json -text -yaml -sql"; DO NOT EDIT.

//
package fileSystemActions

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _FileSystemActionName = "CopyCreateDeleteReadRenameUpdate"

var _FileSystemActionIndex = [...]uint8{0, 4, 10, 16, 20, 26, 32}

func (i FileSystemAction) String() string {
	if i < 0 || i >= FileSystemAction(len(_FileSystemActionIndex)-1) {
		return fmt.Sprintf("FileSystemAction(%d)", i)
	}
	return _FileSystemActionName[_FileSystemActionIndex[i]:_FileSystemActionIndex[i+1]]
}

var _FileSystemActionValues = []FileSystemAction{0, 1, 2, 3, 4, 5}

var _FileSystemActionNameToValueMap = map[string]FileSystemAction{
	_FileSystemActionName[0:4]:   0,
	_FileSystemActionName[4:10]:  1,
	_FileSystemActionName[10:16]: 2,
	_FileSystemActionName[16:20]: 3,
	_FileSystemActionName[20:26]: 4,
	_FileSystemActionName[26:32]: 5,
}

// FileSystemActionString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func FileSystemActionString(s string) (FileSystemAction, error) {
	if val, ok := _FileSystemActionNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to FileSystemAction values", s)
}

// FileSystemActionValues returns all values of the enum
func FileSystemActionValues() []FileSystemAction {
	return _FileSystemActionValues
}

// IsAFileSystemAction returns "true" if the value is listed in the enum definition. "false" otherwise
func (i FileSystemAction) IsAFileSystemAction() bool {
	for _, v := range _FileSystemActionValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for FileSystemAction
func (i FileSystemAction) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for FileSystemAction
func (i *FileSystemAction) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("FileSystemAction should be a string, got %s", data)
	}

	var err error
	*i, err = FileSystemActionString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for FileSystemAction
func (i FileSystemAction) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for FileSystemAction
func (i *FileSystemAction) UnmarshalText(text []byte) error {
	var err error
	*i, err = FileSystemActionString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for FileSystemAction
func (i FileSystemAction) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for FileSystemAction
func (i *FileSystemAction) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = FileSystemActionString(s)
	return err
}

func (i FileSystemAction) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *FileSystemAction) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := FileSystemActionString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
